# coding: utf-8

"""
    logicmonitor_sdk

    LogicMonitor is a cloud-based, full stack, IT infrastructure monitoring solution that allows you to manage your infrastructure from the cloud. logicmonitor_sdk lets you manage your LogicMonitor account programmatically.

    OpenAPI spec version: 1.0.0
    Contact: sdk@logicmonitor.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class Chain(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'period': 'Period',
        'stages': 'list[list[RestRecipient]]',
        'type': 'str'
    }

    attribute_map = {
        'period': 'period',
        'stages': 'stages',
        'type': 'type'
    }

    def __init__(self, period=None, stages=None, type=None):
        """
        Chain - a model defined in Swagger
        """

        self._period = None
        self._stages = None
        self._type = None
        self.discriminator = None

        if period is not None:
          self.period = period
        self.stages = stages
        self.type = type

    @property
    def period(self):
        """
        Gets the period of this Chain.

        :return: The period of this Chain.
        :rtype: Period
        """
        return self._period

    @period.setter
    def period(self, period):
        """
        Sets the period of this Chain.

        :param period: The period of this Chain.
        :type: Period
        """

        self._period = period

    @property
    def stages(self):
        """
        Gets the stages of this Chain.

        :return: The stages of this Chain.
        :rtype: list[list[RestRecipient]]
        """
        return self._stages

    @stages.setter
    def stages(self, stages):
        """
        Sets the stages of this Chain.

        :param stages: The stages of this Chain.
        :type: list[list[RestRecipient]]
        """
        if stages is None:
            raise ValueError("Invalid value for `stages`, must not be `None`")

        self._stages = stages

    @property
    def type(self):
        """
        Gets the type of this Chain.

        :return: The type of this Chain.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """
        Sets the type of this Chain.

        :param type: The type of this Chain.
        :type: str
        """
        if type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")

        self._type = type

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, Chain):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
