# coding: utf-8

"""
    logicmonitor_sdk

    LogicMonitor is a cloud-based, full stack, IT infrastructure monitoring solution that allows you to manage your infrastructure from the cloud. logicmonitor_sdk lets you manage your LogicMonitor account programmatically.

    OpenAPI spec version: 1.0.0
    Contact: sdk@logicmonitor.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class TableRow(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'instances': 'list[InstanceCell]',
        'group_id': 'int',
        'label': 'str',
        'device_id': 'int',
        'device_display_name': 'str',
        'group_full_path': 'str'
    }

    attribute_map = {
        'instances': 'instances',
        'group_id': 'groupId',
        'label': 'label',
        'device_id': 'deviceId',
        'device_display_name': 'deviceDisplayName',
        'group_full_path': 'groupFullPath'
    }

    def __init__(self, instances=None, group_id=None, label=None, device_id=None, device_display_name=None, group_full_path=None):
        """
        TableRow - a model defined in Swagger
        """

        self._instances = None
        self._group_id = None
        self._label = None
        self._device_id = None
        self._device_display_name = None
        self._group_full_path = None
        self.discriminator = None

        if instances is not None:
          self.instances = instances
        if group_id is not None:
          self.group_id = group_id
        if label is not None:
          self.label = label
        self.device_id = device_id
        if device_display_name is not None:
          self.device_display_name = device_display_name
        if group_full_path is not None:
          self.group_full_path = group_full_path

    @property
    def instances(self):
        """
        Gets the instances of this TableRow.

        :return: The instances of this TableRow.
        :rtype: list[InstanceCell]
        """
        return self._instances

    @instances.setter
    def instances(self, instances):
        """
        Sets the instances of this TableRow.

        :param instances: The instances of this TableRow.
        :type: list[InstanceCell]
        """

        self._instances = instances

    @property
    def group_id(self):
        """
        Gets the group_id of this TableRow.

        :return: The group_id of this TableRow.
        :rtype: int
        """
        return self._group_id

    @group_id.setter
    def group_id(self, group_id):
        """
        Sets the group_id of this TableRow.

        :param group_id: The group_id of this TableRow.
        :type: int
        """

        self._group_id = group_id

    @property
    def label(self):
        """
        Gets the label of this TableRow.

        :return: The label of this TableRow.
        :rtype: str
        """
        return self._label

    @label.setter
    def label(self, label):
        """
        Sets the label of this TableRow.

        :param label: The label of this TableRow.
        :type: str
        """

        self._label = label

    @property
    def device_id(self):
        """
        Gets the device_id of this TableRow.

        :return: The device_id of this TableRow.
        :rtype: int
        """
        return self._device_id

    @device_id.setter
    def device_id(self, device_id):
        """
        Sets the device_id of this TableRow.

        :param device_id: The device_id of this TableRow.
        :type: int
        """
        if device_id is None:
            raise ValueError("Invalid value for `device_id`, must not be `None`")

        self._device_id = device_id

    @property
    def device_display_name(self):
        """
        Gets the device_display_name of this TableRow.

        :return: The device_display_name of this TableRow.
        :rtype: str
        """
        return self._device_display_name

    @device_display_name.setter
    def device_display_name(self, device_display_name):
        """
        Sets the device_display_name of this TableRow.

        :param device_display_name: The device_display_name of this TableRow.
        :type: str
        """

        self._device_display_name = device_display_name

    @property
    def group_full_path(self):
        """
        Gets the group_full_path of this TableRow.

        :return: The group_full_path of this TableRow.
        :rtype: str
        """
        return self._group_full_path

    @group_full_path.setter
    def group_full_path(self, group_full_path):
        """
        Sets the group_full_path of this TableRow.

        :param group_full_path: The group_full_path of this TableRow.
        :type: str
        """

        self._group_full_path = group_full_path

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, TableRow):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
