# coding: utf-8

"""
    logicmonitor_sdk

    LogicMonitor is a cloud-based, full stack, IT infrastructure monitoring solution that allows you to manage your infrastructure from the cloud. logicmonitor_sdk lets you manage your LogicMonitor account programmatically.

    OpenAPI spec version: 1.0.0
    Contact: sdk@logicmonitor.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class ServiceNOCItem(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'service_group_name': 'str',
        'name': 'str',
        'group_by': 'str',
        'service_name': 'str'
    }

    attribute_map = {
        'service_group_name': 'serviceGroupName',
        'name': 'name',
        'group_by': 'groupBy',
        'service_name': 'serviceName'
    }

    def __init__(self, service_group_name=None, name=None, group_by=None, service_name=None):
        """
        ServiceNOCItem - a model defined in Swagger
        """

        self._service_group_name = None
        self._name = None
        self._group_by = None
        self._service_name = None
        self.discriminator = None

        self.service_group_name = service_group_name
        self.name = name
        if group_by is not None:
          self.group_by = group_by
        self.service_name = service_name

    @property
    def service_group_name(self):
        """
        Gets the service_group_name of this ServiceNOCItem.

        :return: The service_group_name of this ServiceNOCItem.
        :rtype: str
        """
        return self._service_group_name

    @service_group_name.setter
    def service_group_name(self, service_group_name):
        """
        Sets the service_group_name of this ServiceNOCItem.

        :param service_group_name: The service_group_name of this ServiceNOCItem.
        :type: str
        """
        if service_group_name is None:
            raise ValueError("Invalid value for `service_group_name`, must not be `None`")

        self._service_group_name = service_group_name

    @property
    def name(self):
        """
        Gets the name of this ServiceNOCItem.

        :return: The name of this ServiceNOCItem.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this ServiceNOCItem.

        :param name: The name of this ServiceNOCItem.
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")

        self._name = name

    @property
    def group_by(self):
        """
        Gets the group_by of this ServiceNOCItem.

        :return: The group_by of this ServiceNOCItem.
        :rtype: str
        """
        return self._group_by

    @group_by.setter
    def group_by(self, group_by):
        """
        Sets the group_by of this ServiceNOCItem.

        :param group_by: The group_by of this ServiceNOCItem.
        :type: str
        """

        self._group_by = group_by

    @property
    def service_name(self):
        """
        Gets the service_name of this ServiceNOCItem.

        :return: The service_name of this ServiceNOCItem.
        :rtype: str
        """
        return self._service_name

    @service_name.setter
    def service_name(self, service_name):
        """
        Sets the service_name of this ServiceNOCItem.

        :param service_name: The service_name of this ServiceNOCItem.
        :type: str
        """
        if service_name is None:
            raise ValueError("Invalid value for `service_name`, must not be `None`")

        self._service_name = service_name

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, ServiceNOCItem):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
